// sirene.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <windows.h>
#include <Mmreg.h>
#include <math.h>
#include <malloc.h>
#include <stdlib.h>

struct wav_file_header {
	DWORD riff;
	DWORD chunksize;
	DWORD wave, fmt;
	DWORD subchunksize;
	WAVEFORMAT wf;
	WORD    wBitsPerSample; 
	DWORD data;
	DWORD datasize;
};

bool SaveWAV(const char *fname, short *pcm, DWORD nsamples)
{
	HANDLE f = CreateFile(fname, GENERIC_WRITE, FILE_SHARE_READ, NULL, CREATE_ALWAYS, 0, 0);
	if (f==INVALID_HANDLE_VALUE) return false;
	wav_file_header h;
	h.riff = 'FFIR';
	DWORD datasize = nsamples * 2, w;
	h.chunksize = 36 + datasize;
	h.wave = 'EVAW';
	h.fmt = ' tmf';
	h.subchunksize = 16;
	h.wf.nChannels = 1;
	h.wf.nSamplesPerSec = 44100;
	h.wf.wFormatTag = 1;
	h.wf.nBlockAlign = 2;
	h.wf.nAvgBytesPerSec = 44100 * 2;
	h.wBitsPerSample = 16;
	h.data = 'atad';
	h.datasize = datasize;
	WriteFile(f, &h, sizeof(h), &w, 0);
	WriteFile(f, pcm, datasize, &w, 0);
	CloseHandle(f);
	return true;
}

#define M_PI 3.14159265

int main(int argc, char* argv[])
{
	int output_freq = 44100;
	int T = argc > 1 ? atoi(argv[1]) : 2;
	int Fmin = argc > 2 ? atoi(argv[2]) : 220;
	int Fmax = argc > 3 ? atoi(argv[3]) : 440;
	short *output = (short*)calloc(output_freq * T * 10, 2);
	int Tsamp = output_freq * T;
	int N = 10 * Tsamp;
	int T2 = Tsamp / 2;
	double arg = 0, k = 2 * M_PI / output_freq, df = (double)(Fmax - Fmin) / T2;
	for(int i =0; i < N; i++) {
		output[i] = 32000 * sin(arg);
		double fr = (T2 - abs(T2 - (i % Tsamp))) * df + Fmin;
		arg += fr * k;
	}
	SaveWAV("sirene.wav", output, N);
	free(output);
	return 0;
}

